From 02ea4e4b7b472754458a64f37f61712d55d25c91 Mon Sep 17 00:00:00 2001
From: Steve Langasek <steve.langasek@ubuntu.com>
Date: Fri, 2 Jun 2023 14:54:33 +0000
Subject: [PATCH 2/3] Enable time64 by default for all 32-bit archs, except for
 i386

---
 scripts/Dpkg/Vendor/Debian.pm | 16 ++++++++++------
 1 file changed, 10 insertions(+), 6 deletions(-)

diff --git a/scripts/Dpkg/Vendor/Debian.pm b/scripts/Dpkg/Vendor/Debian.pm
index f3d81bcc2..20d77fea1 100644
--- a/scripts/Dpkg/Vendor/Debian.pm
+++ b/scripts/Dpkg/Vendor/Debian.pm
@@ -107,7 +107,7 @@ sub set_build_features {
     my %use_feature = (
         feature => {
             lfs => 0,
-            time64 => 0,
+            time64 => 1,
         },
         future => {
             lfs => -1,
@@ -160,11 +160,6 @@ sub set_build_features {
     my $opts_build = Dpkg::BuildOptions->new(envvar => 'DEB_BUILD_OPTIONS');
     my $opts_maint = Dpkg::BuildOptions->new(envvar => 'DEB_BUILD_MAINT_OPTIONS');
 
-    foreach my $area (sort keys %use_feature) {
-        $opts_build->parse_features($area, $use_feature{$area});
-        $opts_maint->parse_features($area, $use_feature{$area});
-    }
-
     require Dpkg::Arch;
 
     my $arch = Dpkg::Arch::get_host_arch();
@@ -176,6 +171,15 @@ sub set_build_features {
         ($abi, $os, $cpu) = ('', '', '');
     }
 
+    if ($arch eq 'i386') {
+        $use_feature{feature}{time64} = 0;
+    }
+
+    foreach my $area (sort keys %use_feature) {
+        $opts_build->parse_features($area, $use_feature{$area});
+        $opts_maint->parse_features($area, $use_feature{$area});
+    }
+
     # compatibility: map future=[+-]lfs,time64 onto 'feature'
     if ((my $flag = $use_feature{future}{lfs}) != -1) {
         $use_feature{feature}{lfs} = $flag;
-- 
2.40.1

